

import java.security.AccessController;
import java.security.PrivilegedAction;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.JApplet;
import javax.swing.JButton;
   
import java.awt.BorderLayout;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferInt;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

import javax.imageio.ImageIO;

import java.io.*;
import java.util.*;
import java.nio.charset.*;
import java.net.*;


public class HttpVncServer extends JApplet
{

    String middlemanurl = "http://127.0.0.1/middleman/sendimg.php";
    String sessionid = "foobar";

    JButton btnPause = null;

    SimpleDateFormat formatter =  new SimpleDateFormat("yyyyMMddhhmmss");
    Rectangle screenRect = new Rectangle(Toolkit.getDefaultToolkit().getScreenSize());
   
    
    
    
    private void sendFile(OutputStream out, String name, InputStream in, String fileName) throws Exception
    {
        String o = "\r\nContent-Disposition: form-data; name=\"" + URLEncoder.encode(name,"UTF-8")
                     + "\"; filename=\"" + URLEncoder.encode(fileName,"UTF-8") + "\"\r\n"
                     //+ "Content-Type: image/jpeg\r\n"
                     +"\r\n";
        out.write(o.getBytes(StandardCharsets.UTF_8));
        
        byte[] buffer = new byte[2048];
        for (int n = 0; n >= 0; n = in.read(buffer))
            out.write(buffer, 0, n);
    }
    

    private void sendField(OutputStream out, String name, String field) throws Exception
    {
        String o = "\r\nContent-Disposition: form-data; name=\"" + URLEncoder.encode(name,"UTF-8") + "\"\r\n\r\n";
        out.write(o.getBytes(StandardCharsets.UTF_8));
        out.write(URLEncoder.encode(field,"UTF-8").getBytes(StandardCharsets.UTF_8));
    }
    
    
    public void UploadViaHttp(String surl, String sessionid, File file)
    {
        try {
            URL url = new URL(surl);
            URLConnection con = url.openConnection();
            HttpURLConnection http = (HttpURLConnection)con;
            http.setRequestMethod("POST");
            http.setDoOutput(true);
            
            String boundary = UUID.randomUUID().toString();
            byte[] boundaryBytes = ("\r\n--" + boundary).getBytes(StandardCharsets.UTF_8);
            byte[] finishBoundaryBytes = ("\r\n--" + boundary + "--\r\n").getBytes(StandardCharsets.UTF_8);
            
            http.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
            http.setChunkedStreamingMode(0); // Enable streaming mode with default settings
            
            // Send our fields:
            OutputStream out = http.getOutputStream();

              out.write(boundaryBytes);
              
              sendField(out, "sessionid", sessionid);
              out.write(boundaryBytes);
            
              sendFile(out, "userfile", new FileInputStream(file), "vnc.jpg");
              out.write(finishBoundaryBytes);
            
            out.flush();
            
            InputStream in = http.getInputStream();
            
            in.close();
            out.close();
            http.disconnect();
        } catch(Exception ex) {
            ex.printStackTrace(System.out);
        }
    }
    
    
    public void ScreenShot()
    {
        System.out.println("VNC Server: Screenshot");
        
        AccessController.doPrivileged(new PrivilegedAction() {
            public Object run() { 
            
                try {
                    Robot robot = new Robot();
                    BufferedImage screencapture = robot.createScreenCapture(screenRect);
                    
                    Calendar now = Calendar.getInstance();
                    File imageFile = new File("vnc" + formatter.format(now.getTime()) + ".jpg");
                    ImageIO.write(screencapture, "JPG", imageFile);
                    UploadViaHttp(middlemanurl, sessionid, imageFile);
                } catch(Exception ex) {
                    ex.printStackTrace(System.out);
                }
                return null;
            }
        });
            
    }
    
    @Override
    public void init()
    {
        String sessionidFromPage = this.getParameter("sessionid");
        if(sessionidFromPage != null)
            this.sessionid = sessionidFromPage;
        
        btnPause = new JButton("Start");
        btnPause.addActionListener(e -> {ScreenShot();});
        this.setLayout(new BorderLayout());
        this.add(btnPause,BorderLayout.CENTER);
        
        System.out.println("VNC Server: Ready");
    }

}